####################################################################
# YaWPS - Yet another web Portal System 
#
# Copyright (C) 2001 by Adrian Heiszler (heiszler@gmx.net) 
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the 
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, 
# Boston, MA  02111-1307, USA. 
#
#
# $Id: search.pl,v 1.3 2002/03/31 16:59:53 d3m1g0d Exp $
####################################################################


############
sub search {
############
	if ($input{'query'} eq "") { error("$err{'006'}"); }

	@searchdirs = ("$messagedir", "$topicsdir/articles");

	foreach $dir (@searchdirs) {
		opendir(DIR, "$dir");
		while ($file = readdir DIR) {
			next if ($file =~ /^\./);
			push(@searchfiles, "$dir/$file") if ($file =~ /\.txt/);
		}
		closedir(DIR);
	}

	for ($i = 0; $i < @searchfiles; $i++) {
		$file = $searchfiles[$i];

		open(FILE, "<$file");
		$contents = join('', <FILE>);
		close(FILE);

		$contents =~ tr/A-Z/a-z/;
		$contents =~ s/<[^>]+>/ /g;
		$contents =~ s/ - / /g;
		$contents =~ s/'//g;
		$contents =~ s/[\n\t\`\~\!\@\#\$\%\^\&\*\(\)\_\+\-\=\{\}\|\[\]\\\:\"\;\<\>\?\,\.\/0-9]/ /g;
		@tempwords = split(/ +/, $contents);

		foreach $word (@tempwords) {
			@letters = split(//, $word);
			next if (@letters <= 2);
			next if ($words{$word} =~ /$i /);
			next if ($word eq "");
			next if ($word !~ /^[0-9a-z][0-9a-z]*$/);
			$words{$word} .= "$i ";
		}
	}

	for ($i = 0; $i < @searchfiles; $i++) {
		push(@searchidx, "$i|$searchfiles[$i]\n");
	}

	foreach $key (keys(%words)) {
		push(@searchdb, "$key|$words{$key}\n");
	}

	$input{'query'} =~ s/'//g;
	$input{'query'} =~ tr/A-Z/a-z/;
	@queries = split(/ /, $input{'query'});
	$totalqueries = @queries;
	$match = ($input{'match'} || "all");
	$max = 10;

	$navbar = ">>> $nav{'039'}";
	print_top();

	foreach $line (@searchidx) { 
		@parts = split(/\|/, $line);
		push(@files, $parts[1]);
		$file = $parts[1];
		$matches{$file} = 0;
		$sizes{$file} = $parts[2];
	}

	foreach (@searchdb) { 
		next unless s/^(.*?)\|\s*//;
		$words{$1} = [ split ];
	}

	foreach $query (@queries) { 
		if (@{$words{$query}}) { 
			foreach $index (@{$words{$query}}) {
				$potmatches{$files[$index]} += 1;
			}
		}
	}

	foreach $file (keys(%potmatches)) {
		next if ($match eq "any" && $potmatches{$file} == 0);
		next if ($match eq "all" && $potmatches{$file} < $totalqueries);
	
		push(@matches, $file);
	}

	$nummatches = @matches;

	$output .= qq~$msg{'166'}: <b>"$input{'query'}"</b><br>
$msg{'167'}: <b>$nummatches</b><br>
~;
	if ($nummatches > $max) {
		$output .= "$msg{'168'} $max $msg{'169'}.<br>";
	}
	$output .= qq~<hr size="1">~;

	if ($nummatches == 0) {
		$resultstr .= "<b>$msg{'176'}</b>";
	}
	else {
		for ($i = 0; $i < $nummatches && $i <= $max; $i++) {
			$file = $matches[$i];

			if ($file =~ /$searchdirs[0]/ && $file =~ /(.*)\/(.*)\.txt/) {
				open(FILE, "<$boardsdir/cats.txt");
				@forumcats = <FILE>;
				close(FILE);

				foreach $forumcat (@forumcats) {
					chomp($forumcat);

					open(FILE, "<$boardsdir/$forumcat.cat");
					chomp(@forumcatinfo = <FILE>);
					close(FILE);

					foreach $boardtosearch (@forumcatinfo) {
						open(FILE, "<$boardsdir/$boardtosearch.txt");
						@fmessages = <FILE>;
						close(FILE);

						for ($a = 0; $a < @fmessages; $a++) {
							@item= split(/\|/, $fmessages[$a]);
							chomp($item[10]);
							if ($2 == $item[0]) {
								$ititle = $item[1];
								$iposter = $item[2];
								$iposterid = $item[3];
								$idate = $item[5];
								$iboard = $boardtosearch;
							}
						}
					}
				}
				$iurl = "$cgi?action=forum&amp;board=$iboard&amp;op=display&amp;num=$2";
			}
			if ($file =~ /$searchdirs[1]/ && $file =~ /(.*)\/(.*)\.txt/) {
				open(FILE, "<$topicsdir/articles/$2.txt");
				chomp(@topicdata = <FILE>);
				close(FILE);

				for ($a = 0; $a < 1; $a++) {
					@item = split (/\|/, $topicdata[$a]);
					$ititle = $item[0];
					$iposter = $item[1];
					$iposterid = $item[2];
					$idate = $item[4];
				}
				$iurl = "$cgi?action=viewnews&amp;id=$2";
			}

			$resultstr .= qq~<img src="$imagesurl/urlgo.gif" border="0" alt="">&nbsp;&nbsp;<b><a href="$iurl">$ititle</a></b><br>
<b>$msg{'170'}:</b> <a href="$cgi?action=viewprofile&amp;username=$iposterid">$iposter</a><br>
<b>$msg{'171'}:</b> $idate<br>
<br>
~;
		}
	}

	$resultstr .= qq~<hr size="1">
<b>$msg{'172'} $msg{'166'}:</b><br>
<form action="$cgi" method="post" name="sform" onSubmit="if (document.sform.query.value=='') return false">
<table cellspacing="0" cellpadding="2">
<tr>
<td><b>$msg{'173'}:</b></td>
<td><input name="query" type="text" size="20" value="" maxlength="256"></td>
</tr>
<tr>
<td><b>$msg{'174'}:</b></td>
<td><select name="match">
<option value="all" selected>$msg{'177'}</option>
<option value="any">$msg{'178'}</option>
</select></td>
</tr>
<tr>
<td><input type="submit" value="$btn{'001'}"></td>
</tr>
</table>
</form>
~;

	print "$output $resultstr";

	print_bottom();
	exit;
}

1; # return true
