####################################################################
# YaWPS - Yet another web Portal System 
#
# Copyright (C) 2001 by Adrian Heiszler (heiszler@gmx.net) 
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the 
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, 
# Boston, MA  02111-1307, USA. 
#
#
# $Id: stats.pl,v 1.6 2002/03/31 17:00:24 d3m1g0d Exp $
####################################################################


###########
sub stats {
###########
	$navbar = ">>> $nav{'006'}";
	parse_log();
	print_top();
	topbar();
	html_browser();
	os_system();
	site_stats();
	print_bottom();
	exit;
}

###############
sub parse_log {
###############
	open(DATA,"$logdir/stats.dat") || error("$err{'001'} $logdir/stats.dat");
	@lines = <DATA>;
	close(DATA);

	$total = @lines;
	foreach $line (@lines) {
		if ($line =~ /(.*) - (.*) - \"(.*)\" - \"(.*)\"/) {
			$date = $1;
			($weekday, $day, $time) = split(/ /, $date);
			($hour, $minute) = split(/:/, $time);
			($temp, $month,$year) = split (/-/, $day);
			$host_name = $2;
			$usr_agent = $3;
			$referer = $4;
			$day = "$day "."$weekday";
			$referer{$referer}++;
			$day{$day}++;
			$week_days{$weekday}++;
			$hour{$hour}++;
			push(@user_agents, $usr_agent);
		}
	}
	$total_agent = @user_agents;

	$os{'Windows'} = 0;
	$os{'Mac/PPC'} = 0;
	$os{'Linux'} = 0;
	$os{'SunOS'} = 0;
	$os{'BSD'} = 0;
	$os{'AIX'} = 0;
	$os{'OS/2'} = 0;
	$os{'Irix'} = 0;
	$os{'BeOS'} = 0;
	$os{"$msg{'067'}"} = 0;

	foreach $user_agent (@user_agents) {
		if ($user_agent =~ /MSIE/i) {
			if ($user_agent =~ /Windows 95/i || $user_agent =~ /Windows 98/i || $user_agent =~ /Windows NT/i) {
				$os{'Windows'}++;
				next;
			}
			elsif ($user_agent =~ /Mac_PowerPC/i || $user_agent =~ /Macintosh/i) {
				$os{'Mac/PPC'}++;
				next;
			}
		}
		elsif  ($user_agent =~ /Windows 95/i || $user_agent =~ /Windows 98/i || $user_agent =~ /Windows NT/i) {
			$os{'Windows'}++;
	   		next;
		}
		elsif ($user_agent =~ /Mac_PowerPC/i || $user_agent =~ /Macintosh/i) {
			$os{'Mac/PPC'}++;
			next;
		}
		elsif  ($user_agent =~ /X11/i) {
			if  ($user_agent =~ /Linux/i) {
				$os{'Linux'}++;
				next;
			}
			elsif  ($user_agent =~ /SunOS/i) {
				$os{'SunOS'}++;
				next;
		   	}
		   	elsif  ($user_agent =~ /AIX/i) {
		   		$os{'AIX'}++;
	   			next;
   			}
			elsif  ($user_agent =~ /Irix/i) {
				$os{'Irix'}++;
				next;
			}
		   	else {
   				$os{'BSD'}++;
		   	}
		}
		elsif  ($user_agent =~ /Linux/i) {
			$os{'Linux'}++;
			next;
		}
		elsif  ($user_agent =~ /Win16/i || $user_agent =~ /Windows 3\.1/i) {
			$os{'Windows'}++;
			next;
		}
		elsif  ($user_agent =~ /OS\/2/i) {
			$os{'OS/2'}++;
			next;
		}
		elsif  ($user_agent =~ /BeOS/i) {
			$os{'BeOS'}++;
			next;
		}
		else {
			$os{"$msg{'067'}"}++;
		}
	}

	$browser{'MSIE'} = 0;
	$browser{'Netscape'} = 0;
	$browser{'Opera'} = 0;
	$browser{'Lynx'} = 0;
	$browser{'Konqueror'} = 0;
	$browser{'WebTV'} = 0;
	$browser{"$msg{'066'}"} = 0;
	$browser{"$msg{'067'}"} = 0;

	foreach $agent (@user_agents) {
		if ($agent =~ /Opera/i) {
			$browser{'Opera'}++;
			next;
		}
		elsif ($agent =~ /Lynx/i) {
			$browser{"Lynx"}++;
			next;
		}
		elsif ($agent =~ /Konqueror\/(\d)/i || $agent =~ /Konqueror (\d)/i) {
			$browser{"Konqueror"}++;
			next;
		}
		elsif ($agent =~ /WebTV/i || $agent =~ /WebTV (\d)/i) {
			$browser{"WebTV"}++;
			next;
		}
		elsif ($agent =~ /ArchitextSpider/i || $agent =~ /Scooter/i || $agent =~ /InfoSeek/i || $agent =~ /Lycos/i || $agent =~ /Slurp/i || $agent =~ /UltraSeek/i || $agent =~ /libwww-perl/i) {
			$browser{"$msg{'066'}"}++;
			next;
		}
		elsif ($agent =~ /MSIE/i) {
			if ($agent =~ /MSIE (\d)/i) {
				$browser{"MSIE"}++;
				next;
			}
			else {
				$browser{"$msg{'066'}"}++;
			}
		}
		elsif ($agent =~ /Mozilla/i) {
			if (($agent =~ /Mozilla\/5/i || $agent =~ /Mozilla 5/i) || ($agent =~ /Mozilla\/(\d)/i || $agent =~ /Mozilla (\d)/i)) {
				$browser{'Netscape'}++;
				next;
			}
			else {
				$browser{"$msg{'066'}"}++;
			}
		}
		elsif ($agent ne "") {
			$browser{"$msg{'067'}"}++;
			next;
		}
		else {
			$browser{"$msg{'067'}"}++;
		}
	}

	foreach $count (keys %day) {
		$total_days++;
	}
	$hits_per_day = sprintf ("%.2f",($total/$total_days));
	$hits_per_hour = sprintf ("%.2f",($total/$total_days/24));
}

############
sub topbar {
############
	print qq~<table border="0" cellspacing="0" cellpadding="1" align="center">
<tr>
<td><b>$msg{'068'}</b></td>
<td colspan="2"><b>$total</b></td>
</tr>
<tr>
<td><b>$msg{'069'}</b></td>
<td colspan="2"><b>$total_days</b></td>
</tr>
<tr>
<td><b>$msg{'070'}</b></td>
<td colspan="2"><b>$hits_per_day</b></td>
</tr>
<tr>
<td><b>$msg{'071'}</b></td>
<td colspan="2"><b>$hits_per_hour</b></td>
</tr>
</table>
~;
}

##################
sub html_browser {
##################
	print qq~<br><br>
<table align="center" border="0" cellspacing="0" cellpadding="2">
<tr>
<td align="center" colspan="4"><b>$msg{'072'}</b></td>
</tr>
~;
	my $flag=0;
	my $num=0;
	my ($top_pos, $img_width, $percent);
	foreach $brow (sort { $browser{$b} <=> $browser{$a} } keys %browser) {
		$top_pos = $browser{$brow} if ($flag == 0);
		$img_width = int($browser{$brow}*200/$top_pos);
		$percent = sprintf ("%.2f", ($browser{$brow}/$total_agent*100));
		$brow_pic = $brow;
		$brow_pic =~ tr/A-Z/a-z/;
		if ($brow eq $msg{'066'}) { $brow_pic = "searchengines"; }
		if ($brow eq $msg{'067'}) { $brow_pic = "unknown"; }
		print qq~<tr>
<td><img src="$imagesurl/stats/$brow_pic.gif" alt=""></td>
<td>$brow</td>
<td>$browser{$brow}</td>
<td><img src="$imagesurl/leftbar.gif" width="7" height="14" alt=""><img src="$imagesurl/mainbar.gif" width="$img_width" height="14" alt=""><img src="$imagesurl/rightbar.gif" width="7" height="14" alt=""> $percent\%</td>
</tr>
~;
		$flag = 1;
	}
	print "</table>\n";
}

###############
sub os_system {
###############
	print qq~<br><br>
<table align="center" border="0" cellspacing="0" cellpadding="2">
<tr>
<td align="center" colspan="4"><b>$msg{'073'}</b></td>
</tr>
~;
	my $flag = 0;
	my $num = 0;
	my ($top_pos, $img_width, $percent);
	foreach $os_sys (sort { $os{$b} <=> $os{$a} } keys %os) {
		$top_pos = $os{$os_sys} if ($flag == 0);
		$img_width = int($os{$os_sys}*200/$top_pos);
		$percent = sprintf ("%.2f", ($os{$os_sys}/$total_agent*100));
		$os_pic = $os_sys;
		$os_pic =~ tr/A-Z/a-z/;
		if ($os_pic eq "mac/ppc") { $os_pic = "mac"; }
		if ($os_pic eq "os/2") { $os_pic = "os2"; }
		if ($os_sys eq $msg{'067'}) { $os_pic = "unknown"; }
		print qq~<tr>
<td><img src="$imagesurl/stats/$os_pic.gif" alt=""></td>
<td width="90">$os_sys</td>
<td>$os{$os_sys}</td>
<td><img src="$imagesurl/leftbar.gif" width="7" height="14" alt=""><img src="$imagesurl/mainbar.gif" width="$img_width" height="14" alt=""><img src="$imagesurl/rightbar.gif" width="7" height="14" alt=""> $percent\%</td>
</tr>
~;
		$flag = 1;
	}
	print "</table>\n";
}

################
sub site_stats {
################
	open(FILE, "<$memberdir/memberlist.dat");
	@memberlist = <FILE>;
	close(FILE);

	$memcount = @memberlist;
	undef @catnames;
	undef @catlinks;

	open(FILE, "<$topicsdir/cats.dat");
	chomp(@topicscat = <FILE>);
	close(FILE);

	for ($i = 0; $i < @topicscat; $i++) { $topicscatcount++; }

	foreach (@topicscat) {
		@item = split(/\|/, $_);
		push(@catnames, $item[0]);
		push(@catlinks, $item[1]);
	}

	foreach $curcat (@catlinks) {
		open(FILE, "<$topicsdir/$curcat.cat");
		chomp(@articles = <FILE>);
		close(FILE);

		$articlecount = 0;
		for ($a = 0; $a < @articles; $a++) {
			($dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $areplies, $dummy) = split(/\|/, $articles[$a]);
			$articlecount++;
			$repcount = $repcount+$areplies;
		}
		$totala = $totala+$articlecount;
		if ($repcount == 0) { $repcount = 0; }
	}

	open (FILE, "<$topicsdir/newarticles.dat");
	@newarticles = <FILE>;
	close(FILE);

	if (@newarticles == 0) { $newarticlescount = 0; }
	for ($i = 0; $i < @newarticles; $i++) { $newarticlescount++; }

	open(FILE, "<$boardsdir/cats.txt");
	chomp(@categories = <FILE>);
	close(FILE);

	open(FILE, "<$memberdir/memberlist.dat");
	@memberlist = <FILE>;
	close(FILE);

	$memcount = @memberlist;
	$totalm = 0;
	$totalt = 0;

	foreach $curcat (@categories) {
		open(FILE, "<$boardsdir/$curcat.cat") || error("$err{'001'} $boardsdir/$curcat.cat");
		chomp(@catinfo = <FILE>);
		close(FILE);

		if ($catinfo[1] ne "") {
			if ($settings[7] ne $userlevel[0] && $settings[7] ne $catinfo[1]) { next; }
		}

		foreach $curboard (@catinfo) {
			if ($curboard ne $catinfo[0] && $curboard ne $catinfo[1]) {

				open(FILE, "<$boardsdir/$curboard.txt") || error("$err{'001'} $boardsdir/$curboard.txt");
				chomp(@messages = <FILE>);
				close(FILE);

				$tm = @messages;
				$messagecount = 0;
				for ($a = 0; $a < @messages; $a++) {
					($dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $mreplies, $dummy, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $messages[$a]);
					$messagecount++;
					$messagecount = $messagecount+$mreplies;
				}
				$totalm = $totalm+$messagecount;
				$totalt = $totalt+$tm;
			}
		}
	}

	open(FILE, "<$linksdir/linkcats.dat");
	@lnkcatscount = <FILE>;
	close(FILE);

	for ($i = 0; $i < @lnkcatscount; $i++) { $lnkcatscount++; }

	open(FILE, "<$linksdir/linkcats.cnt");
	$lnkcount = <FILE>;
	close(FILE);

	print qq~<br><br>
<table align="center" border="0" cellspacing="0" cellpadding="2">
<tr>
<td align="center" colspan="2"><b>$msg{'149'}</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/users.gif" alt="">&nbsp;$msg{'074'} </td>
<td><b>$memcount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/topics.gif" alt="">&nbsp;$msg{'075'} </td>
<td><b>$topicscatcount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/articles.gif" alt="">&nbsp;$msg{'076'} </td>
<td><b>$totala</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/waiting.gif" alt="">&nbsp;$msg{'077'} </td>
<td><b>$newarticlescount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/comments.gif" alt="">&nbsp;$msg{'078'} </td>
<td><b>$repcount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/topics.gif" alt="">&nbsp;$msg{'079'} </td>
<td><b>$totalt</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/forummessages.gif" alt="">&nbsp;$msg{'080'} </td>
<td><b>$totalm</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/topics.gif" alt="">&nbsp;$msg{'081'}</td>
<td><b>$lnkcatscount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/links.gif" alt="">&nbsp;$msg{'082'} </td>
<td><b>$lnkcount</b></td>
</tr>
<tr>
<td><img src="$imagesurl/stats/scriptver.gif" alt="">&nbsp;$msg{'083'} </td>
<td><b>$scriptver</b></td>
</tr>
</table>
~;

}

1; # return true
