####################################################################
# YaWPS - Yet another web Portal System 
#
# Copyright (C) 2001 by Adrian Heiszler (heiszler@gmx.net) 
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the 
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, 
# Boston, MA  02111-1307, USA. 
#
#
# $Id: subs.pl,v 1.7 2002/03/31 17:00:46 d3m1g0d Exp $
####################################################################


################
sub loadcookie {
################
	$cookie_expdate = "Thu, 01-Jan-2099 00:00:00 GMT";
	foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
		($cookie, $value) = split(/=/);
		if ($cookie eq $cookieusername) { $username = $value; }
		if ($cookie eq $cookiepassword) { $password = $value; }
		if ($cookie eq $cookieusertheme) { $usertheme = $value; }
	}
}

##############
sub loaduser {
##############
	if ($username eq "") {
		$username = $anonuser;
		$usertheme = "standard";
	}
	if ($username ne $anonuser) {
		open(FILE, "<$memberdir/$username.dat");
		@settings = <FILE>;
		close(FILE);

		for( $i = 0; $i < @settings; $i++ ) {
			$settings[$i] =~ s~[\n\r]~~g;
		}

		if ($settings[0] ne $password && $action ne "logout") { error("$err{'002'}"); }
		else {
			$realname = $settings[1];
			$realemail = $settings[2];
		}
	}
	unless ($username) {
		print qq~Set-Cookie: $cookieusername=; path=/; expires=$cookie_expdate;\n~;
		print qq~Set-Cookie: $cookiepassword=; path=/; expires=$cookie_expdate;\n~;
		print qq~Set-Cookie: $cookieusertheme=; path=/; expires=$cookie_expdate;\n~;

		$username = $anonuser;
		$password = "";
		$usertheme = "standard";
		@settings = ();
		$realname = "";
		$realemail = "";
		$ENV{'HTTP_COOKIE'} = "";
	}
}

#################
sub logvisitors {
#################
	open(FILE, "<$datadir/log.dat");
	chomp(@entries = <FILE>);
	close(FILE);

	open(FILE, ">$datadir/log.dat");
	lock(FILE);
	$field = $username;
	if ($field eq $anonuser) { $field = $ENV{'REMOTE_ADDR'}; }
	print FILE "$field|$date\n";
	foreach $curentry (@entries) {
		($name, $value) = split(/\|/, $curentry);
		$date1 = $value;
		$date2 = $date;
		calctime();
		if ($name ne $field && $result <= 15 && $result >= 0) { print FILE "$curentry\n"; }
	}
	close(FILE);
}

################
sub print_main {
################
	open(FILE, "<$datadir/welcomemsg.txt");
	chomp(@lines = <FILE>);
	close(FILE);

	$message = $lines[1];
	doubbc();

	$welcome = qq~<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td><p class="texttitle">$lines[0]</p>
$message<br>
<br><br></td>
</tr>
</table>
~;
	require "$sourcedir/topics.pl";
	viewnews();
	exit;
}

###############
sub print_top {
###############
	require "$themesdir/$usertheme/theme.pl"; getvars();
	require "$themesdir/$usertheme/header.pl";
}

##################
sub print_bottom {
##################
	require "$themesdir/$usertheme/footer.pl";
}

##############
sub menuitem {
##############
	require "$themesdir/$usertheme/theme.pl"; menuitem();
}

###############
sub boxheader {
###############
	require "$themesdir/$usertheme/theme.pl"; boxheader();
}

###############
sub boxfooter {
###############
	require "$themesdir/$usertheme/theme.pl"; boxfooter();
}

###############
sub userpanel {
###############
	menuitem("help&amp;topic=$info{'action'}", "$nav{'010'}");
	menuitem("register", "$nav{'011'}");
	if ($username ne $anonuser) { 
		menuitem("editprofile&amp;username=$username", "$nav{'016'}");
		menuitem("memberlist", "$nav{'019'}");
		if ($enable_userarticles == 1) { menuitem("postnews", "$nav{'023'}"); }
	}
	if ($settings[7] eq $userlevel[0]) { 
		menuitem("admin\&amp\;op=siteadmin", "$nav{'042'}"); 
	}
	if ($username eq $anonuser) { menuitem("login", "$nav{'012'}"); }
	else { menuitem("logout", "$nav{'034'}"); }
}

################
sub userstatus {
################
	$guests = 0;
	$users = 0;

	open(FILE, "<$datadir/log.dat");
	chomp(@entries = <FILE>);
	close(FILE);

	foreach $curentry (@entries) {
		($name, $value) = split(/\|/, $curentry);
		if($name =~ /\./) { ++$guests }
		else { ++$users	}
	}
	if ($username eq $anonuser) {
		print qq~<tr>
<td class="cat">$msg{'002'} '$username'</td>
</tr>
~;
	}
	else {
		open(FILE, "<$memberdir/$username.dat");
		chomp(@sett = <FILE>);
		close(FILE);

		if ($username ne $anonuser) { 
			open(FILE, "<$memberdir/$username.msg"); 
			@immessages = <FILE>; 
			close(FILE);

			$mnum = @immessages; 
			$messnum = $mnum; 
		}
		print qq~<tr>
<td class="cat">$msg{'002'} '$sett[1]'</td>
</tr>
<tr>
<td class="cat">$msg{'003'} <a href="$cgi?action=im" class="menu">$mnum</a></td>
</tr>
~;
	}
	print qq~<tr>
<td class="cat">$msg{'004'} $guests<br>
$msg{'005'} $users</td>
</tr>
~;
}

###############
sub show_help {
###############
	$requested_topic = $info{'topic'};
	if ($requested_topic eq "")  { $requested_topic = "main"; }
	
	$navbar = ">>> $nav{'010'}";
	print_top();

	foreach $help_topic (keys %help) {
		if ($requested_topic eq $help_topic) {
			$found_help_topic = $help{$help_topic};
			last;
		}
	}

	if (defined $found_help_topic) {
		print $found_help_topic;
	}
	else {
		print $msg{'189'};
	}

	print_bottom();
	exit;
}

######################
sub latestforumposts {
######################
	open(FILE, "<$boardsdir/cats.txt");
	@fcats = <FILE>;
	close(FILE);

	%myforumdata= ();

	foreach $fcat (@fcats) {
		$fcat =~ s/[\n\r]//g;

		open(FILE, "<$boardsdir/$fcat.cat");
		@fcatinfo = <FILE>;
		close(FILE);

		$fcatinfo[1] =~ s/[\n\r]//g;
		foreach $selboard (@fcatinfo) {
			if ($selboard ne $fcatinfo[0] && $selboard ne $fcatinfo[1]) {
				$selboard =~ s/[\n\r]//g;

				open(FILE, "<$boardsdir/$selboard.txt");
				@fposts = <FILE>;
				close(FILE);

				for ($f = 0; $f < @fposts; $f++) {
					($fpnum, $fptitle, $dummy, $dummy, $dummy, $fpdate, $dummy, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $fposts[$f]);
					chomp($dummy);

					$myforumlink = qq~<a href="$cgi?action=forum&amp;board=$selboard&amp;op=display&amp;num=$fpnum" class="menu">$fptitle</a>
~;
;

					($date, $time) = split(/ - /, $fpdate);
					($day, $month, $year) = split(/\//, $date);
					($hour, $min, $sec) = split (/:/, $time);
					$mytotaltime = (($year+2000)*365+$month*30+$day)*24*60*60+$hour*60*60+$min*60+$sec; 
					$myforumdata{$mytotaltime} = $myforumlink;
				}
			}
		}
	}
	@myforumnum = sort { $b <=> $a } keys %myforumdata;
}

#############
sub readlog {
#############
	local ($field) = @_;
	if($username ne $anonuser) {
		open(FILE, "<$memberdir/$username.log");
		@entries = <FILE>;
		close(FILE);

		foreach $curentry (@entries) {
			$curentry =~ s/[\n\r]//g;
			($name, $value) = split(/\|/, $curentry);
			if ($name eq $field) { return $value; }
		}
	}
}

##############
sub writelog {
##############
	local($field) = @_;
	if ($username ne $anonuser) {
		open(FILE, "<$memberdir/$username.log");
		@entries = <FILE>;
		close(FILE);

		open(FILE, ">$memberdir/$username.log");
		lock(FILE);
		print FILE "$field|$writedate\n";
		foreach $curentry (@entries) {
			$curentry =~ s/[\n\r]//g;
			($name, $value) = split(/\|/, $curentry);
			$date1 = $value;
			$date2 = $date;
			calcdifference();
			if ($name ne $field && $result <= $max_log_days_old) { print FILE "$curentry\n"; }
		}
		close(FILE);
	}
}

############
sub logips {
############
	@skip = ("127.0.0.1");
	$ip_time = 5;
	$check = 0;

	if (@skip) {
		foreach $ips (@skip) {
			if ($ENV{'REMOTE_ADDR'} =~ /$ips/) {
				$check = 1;
				last;
			}
		}
	}
	if ($check == 0) { 
		my $this_time = time();

		open(FILE,"<$logdir/ip.log");
		my @lines = <FILE>;
		close(FILE);

		open(FILE,">$logdir/ip.log");
		lock(FILE);
		foreach $visitor (@lines) {
			($ip_addr,$time_stamp) = split(/\|/, $visitor);
			if ($this_time < $time_stamp + (60*$ip_time)) {
				if ($ip_addr eq $ENV{'REMOTE_ADDR'}) { $check = 1; }
				else { print FILE "$ip_addr|$time_stamp"; }
			}
		}
		print FILE "$ENV{'REMOTE_ADDR'}|$this_time\n";
		close(FILE);
	}

	if ($check == 0) { 
		if ($ENV{'REMOTE_HOST'}) { $host = $ENV{'REMOTE_HOST'}; }
		else {
			$ip_address = $ENV{'REMOTE_ADDR'};
			@numbers = split(/\./, $ip_address);
			$ip_number = pack("C4", @numbers);
			$host = (gethostbyaddr($ip_number, 2))[0];
		}
		if ($host eq "") { $host = $ENV{'REMOTE_ADDR'}; }

		($value, $referer) = split(/=/, $query);
		if ($referer) {
			if ($referer =~ /(http:\/\/.*\.[a-z]{2,4}\/)/i) { $referer = $1; }
		}
		else { $referer = "-"; }

		open(FILE, ">>$logdir/stats.dat");
		lock(FILE);
		print FILE ("$logdate - $host - \"$ENV{'HTTP_USER_AGENT'}\" - \"$referer\"\n");
		close (FILE);
	}
}

################
sub htmlescape {
################
	my $text = shift;

	$text =~ s/&/&amp;/g;
	$text =~ s/"/&quot;/g;
	$text =~ s/  / \&nbsp;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$text =~ s/\cM//g;
	$text =~ s/\n/<br>/g;
	$text =~ s/\|/<pipe>/g;

	return $text;
}

################
sub htmltotext {
################
	my $html = shift;

	$html =~ s~<br>~\n~gi;
	$html =~ s~<\/*(blockquote|ul|li|p)[^<>]*>~\n\n~gi;
	$html =~ s~<a href=\"*([^\s<>\"]+)\"*[^>]*>([\s\S]+?)<\/a>~$2 (link: $1)~gi;
	$html =~ s~<[^>]+>~~g;
	$html =~ s~\"~&quot;~g;

	return $html;
}

############
sub doubbc {
############
	if ($message =~ /^\#nosmileys/) { $message =~ s/^\#nosmileys//; }
	else { 
		$message =~ s~\[bones\]~<img src="$imagesurl/forum/smilies/bones.gif" alt="">~g;
		$message =~ s~\[bounce\]~<img src="$imagesurl/forum/smilies/bounce.gif" alt="">~g;
		$message =~ s~\:-\?~<img src="$imagesurl/forum/smilies/confused.gif" alt="">~g;
		$message =~ s~\[confused\]~<img src="$imagesurl/forum/smilies/confused.gif" alt="">~g;
		$message =~ s~\Q8)\E~<img src="$imagesurl/forum/smilies/cool.gif" alt="">~g;
		$message =~ s~\Q8-)\E~<img src="$imagesurl/forum/smilies/cool.gif" alt="">~g;
		$message =~ s~\[cool\]~<img src="$imagesurl/forum/smilies/cool.gif" alt="">~g;
		$message =~ s~\[cry\]~<img src="$imagesurl/forum/smilies/cry.gif" alt="">~g;
		$message =~ s~\:o~<img src="$imagesurl/forum/smilies/eek.gif" alt="">~g;
		$message =~ s~\:\-o~<img src="$imagesurl/forum/smilies/eek.gif" alt="">~g;
		$message =~ s~\[eek\]~<img src="$imagesurl/forum/smilies/eek.gif" alt="">~g;
		$message =~ s~\[evil\]~<img src="$imagesurl/forum/smilies/evil.gif" alt="">~g;
		$message =~ s~\:\(~<img src="$imagesurl/forum/smilies/frown.gif" alt="">~g;
		$message =~ s~\:-\(~<img src="$imagesurl/forum/smilies/frown.gif" alt="">~g;
		$message =~ s~\[frown\]~<img src="$imagesurl/forum/smilies.gif" alt="">~g;
		$message =~ s~\:D~<img src="$imagesurl/forum/smilies/grin.gif" alt="">~g;
		$message =~ s~\:-D~<img src="$imagesurl/forum/smilies/grin.gif" alt="">~g;
		$message =~ s~\[grin\]~<img src="$imagesurl/forum/smilies/grin.gif" alt="">~g;
		$message =~ s~\[lol\]~<img src="$imagesurl/forum/smilies/lol.gif" alt="">~g;
		$message =~ s~\:x~<img src="$imagesurl/forum/smilies/mad.gif" alt="">~g;
		$message =~ s~\:-x~<img src="$imagesurl/forum/smilies/mad.gif" alt="">~g;
		$message =~ s~\[mad\]~<img src="$imagesurl/forum/smilies/mad.gif" alt="">~g;
		$message =~ s~\[ninja\]~<img src="$imagesurl/forum/smilies/ninja.gif" alt="">~g;
		$message =~ s~\[nonsense\]~<img src="$imagesurl/forum/smilies/nonsense.gif" alt="">~g;
		$message =~ s~\[oops\]~<img src="$imagesurl/forum/smilies/oops.gif" alt="">~g;
		$message =~ s~\[razz\]~<img src="$imagesurl/forum/smilies/razz.gif" alt="">~g;
		$message =~ s~\[rolleyes\]~<img src="$imagesurl/forum/smilies/rolleyes.gif" alt="">~g;
		$message =~ s~\:\)~<img src="$imagesurl/forum/smilies/smile.gif" alt="">~g;
		$message =~ s~\:-\)~<img src="$imagesurl/forum/smilies/smile.gif" alt="">~g;
		$message =~ s~\[smile\]~<img src="$imagesurl/forum/smilies/smile.gif" alt="">~g;
		$message =~ s~\:P~<img src="$imagesurl/forum/smilies/tongue.gif" alt="">~g;
		$message =~ s~\:-P~<img src="$imagesurl/forum/smilies/tongue.gif" alt="">~g;
		$message =~ s~\[tongue\]~<img src="$imagesurl/forum/smilies/tongue.gif" alt="">~g;
		$message =~ s~\;\)~<img src="$imagesurl/forum/smilies/wink.gif" alt="">~g;
		$message =~ s~\;-\)~<img src="$imagesurl/forum/smilies/wink.gif" alt="">~g;
		$message =~ s~\[wink\]~<img src="$imagesurl/forum/smilies/wink.gif" alt="">~g;
	}
	
	$message =~ s~\[\[~\{\{~g;
	$message =~ s~\]\]~\}\}~g;
	$message =~ s~\n\[~\[~g;
	$message =~ s~\]\n~\]~g;

	$message =~ s~\<br\>~ <br>~g;
	$message =~ s~\[hr\]\n~<hr size="1">~g;
	$message =~ s~\[hr\]~<hr size="1">~g;

	$message =~ s~\[b\]~<b>~isg;
	$message =~ s~\[\/b\]~</b>~isg;

	$message =~ s~\[i\]~<i>~isg;
	$message =~ s~\[\/i\]~</i>~isg;

	$message =~ s~\[u\]~<u>~isg;
	$message =~ s~\[\/u\]~</u>~isg;
	
	$message =~ s~\[img\](.+?)\[\/img\]~<img src="$1" alt="">~isg;
	
	$message =~ s~\[color=(\S+?)\]~<font color="$1">~isg;
	$message =~ s~\[\/color\]~</font>~isg;
	
	$message =~ s~\[quote\]<br>(.+?)<br>\[\/quote\]~<blockquote><hr>$1<hr></blockquote>~isg;
	$message =~ s~\[quote\](.+?)\[\/quote\]~<blockquote><hr><b>$1</b><hr></blockquote>~isg;

	$message =~ s~\[fixed\]~<font face="Courier New">~isg;
	$message =~ s~\[\/fixed\]~</font>~isg;

	$message =~ s~\[sup\]~<sup>~isg;
	$message =~ s~\[\/sup\]~</sup>~isg;

	$message =~ s~\[sub\]~<sub>~isg;
	$message =~ s~\[\/sub\]~</sub>~isg;

	$message =~ s~\[center\]~<center>~isg;
	$message =~ s~\[\/center\]~</center>~isg;

	$message =~ s~\[list\]~<ul>~isg;
	$message =~ s~\[\*\]~<li>~isg;
	$message =~ s~\[\/list\]~</ul>~isg;

	$message =~ s~\[pre\]~<pre>~isg;
	$message =~ s~\[\/pre\]~</pre>~isg;

	$message =~ s~\[code\](.+?)\[\/code\]~<blockquote><font face="Courier New">code:</font><hr><font face="Courier New"><pre>$1</pre></font><hr></blockquote>~isg;

	$message =~ s~\[email\]\s*(\S+?\@\S+?)\s*\[/email\]~<a href="mailto:$1">$1</a>~isg;
	$message =~ s~\[email=\s*(\S+?\@\S+?)\]\s*(.*?)\s*\[/email\]~<a href="mailto:$1">$2</a>~isg;

	$message =~ s~\[url\]www\.\s*(.+?)\s*\[/url\]~<a href="http://www.$1" target="_blank">www.$1</a>~isg;
	$message =~ s~\[url=\s*(\w+\://.+?)\](.+?)\s*\[/url\]~<a href="$1" target="_blank">$2</a>~isg;
	$message =~ s~\[url=\s*(.+?)\]\s*(.+?)\s*\[/url\]~<a href="http://$1" target="_blank">$2</a>~isg;
	$message =~ s~\[url\]\s*(.+?)\s*\[/url\]~<a href="$1" target="_blank">$1</a>~isg;

	$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1<a href="$2" target="_blank">$2</a>~isg;
	$message =~ s~([^\"\=\[\]/\:\.]|[\n\b]|\A)\\*(www\.[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1<a href="http://$2" target="_blank">$2</a>~isg;

	$message =~ s~\{\{~\[~g;
	$message =~ s~\}\}~\]~g;
	$message =~ s~\<pipe\>~\|~g; 
}

############
sub getcgi {
############
	read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

	@pairs = split(/&/, $input);
	foreach $pair (@pairs) {

	        ($name, $value) = split(/=/, $pair);
	        $name =~ tr/+/ /;
	        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	        $value =~ tr/+/ /;
	        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	        $input{$name} = $value;
	}

	@vars = split(/&/, $ENV{QUERY_STRING});
	foreach $var (@vars) {
	        ($v,$i) = split(/=/, $var);
	        $v =~ tr/+/ /;
	        $v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	        $i =~ tr/+/ /;
	        $i =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	        $i =~ s/<!--(.|\n)*-->//g;
	        $info{$v} = $i;
	}

	$action = $info{'action'};
	$currentboard = $info{'board'};
	$op = $info{'op'};
}

#############
sub getdate {
#############
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time + 3600*$timeoffset);
	$mon_num = $mon+1;
	$savehour = $hour;
	$hour = "0$hour" if ($hour < 10);
	$min = "0$min" if ($min < 10);
	$sec = "0$sec" if ($sec < 10);
	$saveyear = ($year % 100);
	$year = 1900 + $year;
	$mon_num = "0$mon_num" if ($mon_num < 10);
	$mday = "0$mday" if ($mday < 10);
	$saveyear = "0$saveyear" if ($saveyear < 10);
	$date = "$mday/$mon_num/$saveyear - $hour\:$min\:$sec";
	$shortdate = "$days[$wday], $mday.$mon_num.$year";
	$logdate = "$days[$wday] $mday-$months[$mon]-$year $hour:$min";
}

####################
sub calcdifference {
####################
	($dates, $times) = split(/ /, $date1);
	($month, $day, $year) = split(/\//, $dates);
	$number1 = ($year*365)+($month*30)+$day;
	($dates, $dummy) = split(/ /, $date2);
	($month, $day, $year) = split(/\//, $dates);
	$number2 = ($year*365)+($month*30)+$day;
	$result = $number2-$number1;
}

##############
sub calctime {
##############
	($dummy, $times) = split(/ - /, $date1);
	($hour, $min, $sec) = split(/:/, $times);
	$number1 = ($hour*60)+$min;
	($dummy, $times) = split(/ - /, $date2);
	($hour, $min, $sec) = split(/:/, $times);
	$number2 = ($hour*60)+$min;
	$result = $number2-$number1;
}

###########
sub error {
###########
	local($e) = @_;
	$navbar = ">>> $nav{'001'}";
	print_top();
	print qq~<p>
<b>$msg{'001'}</b><br>
$e
</p>
~;
	print_bottom();
	exit;
}

#########
sub die {
#########
	local($e) = @_;
	print "$msg{'001'}: $e";
	die $error;
}

##########
sub lock {
##########
	local($file) = @_;
	if ($use_flock) { flock($file, $LOCK_EX); }
}

############
sub unlock {
############
	local($file) = @_;
	if ($use_flock) { flock($file, $LOCK_UN); }
}

###############
sub sendemail {
###############
	my ($to, $subject, $message, $from) = @_;

	if ($from) { $webmaster_email = $from; }
	$to =~ s/[ \t]+/, /g;
	$webmaster_email =~ s/.*<([^\s]*?)>/$1/;
	$message =~ s/^\./\.\./gm;
	$message =~ s/\r\n/\n/g;
	$message =~ s/\n/\r\n/g;
	$smtp_server =~ s/^\s+//g;
	$smtp_server =~ s/\s+$//g;

 	if ($mailtype == 1) {
		($x, $x, $x, $x, $here) = gethostbyname($null);
		($x, $x, $x, $x, $there) = gethostbyname($smtp_server);
		$thisserver = pack('S n a4 x8', 2, 0, $here);
		$remoteserver = pack('S n a4 x8', 2, 25, $there);
		(!(socket(S, 2, 1, 6))) && (error("Connect error! socket"));
		(!(bind(S, $thisserver))) && (error("Connect error! bind"));
		(!(connect(S, $remoteserver))) && (error("!! connection to $smtp_server has failed!"));

		my ($oldfh) = select(S);
		$| = 1;
		select($oldfh);

		$_ = <S>; 
		($_ !~ /^220/) && (error("Sending Email: data in Connect error - 220")); 

		print S "HELO $smtp_server\r\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: data in Connect error - 250")); 

		print S "MAIL FROM:<$webmaster_email>\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: 'From' address not valid")); 

		print S "RCPT TO:<$to>\n";
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: 'Recipient' address not valid")); 

		print S "DATA\n";
		$_ = <S>;
		($_ !~ /^354/) && (error("Sending Email: Message send failed - 354")); 
	}

	if ($mailtype == 0) {
		open(S, "| $mailprogram -t") || error("$err{'008'}");
	}

	print S "To: $to\n";
	print S "From: $webmaster_email\n";
	print S "Subject: $subject\n\n";
	print S "$message";
	print S "\n.\n";

	if ($mailtype == 1) {
		$_ = <S>;
		($_ !~ /^250/) && (error("Sending Email: Message send failed - try again - 250")); 
		print S "QUIT\n";
	}

	close(S);
	return(1);
}

1; # return true
